////////////////////////////////////////////////////////////////////
// IMPORTANTE LEER ESTO ANTES DE EMPEZAR
//
// Este archivo explica el uso de Doxygen orientado a aplicaciones
// en C. Se debe tener instalado Doxygen y se recomienda usar el
// wizard de Doxygen, doxywizard.
// Ver http://www.stack.nl/~dimitri/doxygen/index.html.
//
// Para generar la documentacion primero se debe generar un Doxyfile.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Ver Doxyfile adjunto para ver qué campos se pueden configurar.
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// En el wizard, pestaña expert, tenemos todos estos campos y si nos
// paramos arriba de cada uno tenemos una descripcion de que es lo
// que hace en una ventanita auxiliar.
//
// Se debe configurar el formato de los archivos de salida, así como
// el directorio del que se sirve los archivos para incluir en la
// documentacion y los tipos de archivo que incluye (*.h, *.c).
// Tambien se pueden configurar muchas mas cosas, como el idioma,
// ver como esta configurado el archivo Doxyfile adjunto como
// referencia.
//
// Cuando estamos satisfechos con la configuracion vamos a la pestaña
// Run y hacemos Run doxygen. Podemos ver la salida en formato HTML
// pulsando un boton que aparece abajo.
//
// Para ver la salida html que genera este archivo con el Doxyfile adjunto,
// ejecutar en un web browser el archivo " _doxygen_readme_8h.html"
// que esta bajo el directorio html.
////////////////////////////////////////////////////////////////////

/**
 * @file DoxygenReadme.h
 * 
 * @version 1.0
 * @author  Yo <yo@fing.edu.uy>
 * @date 30 Marzo 2017
 * 
 * @brief Este es el encabezado de mi_encabezado.c, modulo que
 * implementa esto y aquello. Usando brief, hacemos que aparezca al
 * principio.
 * 
 * @paragraph
 * 
 * Aca explicamos que hace el modulo con detalle. Para ver como se
 * hacen cosas mas complejas con Doxygen, visitar el sitio de
 * referencia.
 * 
 * @see http://www.stack.nl/~dimitri/doxygen/index.html
 *
 */


/** Este es un ejemplo de un macro
 * 
 * Cuando MIMACRO se habilita, hace esto y aquello.
 */
#define MI_MACRO 1

#ifndef DOXYGEN_SHOULD_SKIP_THIS

// codigo que Doxygen se debe saltear. Para que funcione, seteamos
// en el Doxyfile: PREDEFINED = DOXYGEN_SHOULD_SKIP_THIS
#if MI_MACRO
#define PRINTF(...) printf(__VA_ARGS__)
#else
#define PRINTF(...)
#endif

#endif // DOXYGEN_SHOULD_SKIP_THIS


/** Defino un tipo de dato */
typedef void (function_t)();


/** Defino union para acceder a 1 byte bit a bit, al byte,
 * al nibble inferior y al superior.
 */
typedef union {
  unsigned char byte;/**< Que hace esto. */
  struct {
    unsigned char bit0 : 1;
    unsigned char bit1 : 1;
    unsigned char bit2 : 1;
    unsigned char bit3 : 1;
    unsigned char bit4 : 1;
    unsigned char bit5 : 1;
    unsigned char bit6 : 1;
    unsigned char bit7 : 1;
  } bit;
  struct {
    unsigned char nibble0 : 4;/**< Para que sirve esto */
    unsigned char nibble1 : 4;/**< Para que sirve esto otro */
  } nibble;
} registro_t;


/** Variable local del modulo
 * 
 * Para que una variable static aparezca habilitamos EXTRACT_STATIC
 */
static int numero;

/**
  * @brief Resumidamente esto hace mi funcion operar.
  * 
  * Mas en detalle esto es lo que hace mi funcion operar y asi es
  * como la implemente.
  * 
  * @param int a: un entero.
  * @param int b: otro entero.
  * @return int: devuelve un entero.
  */
int operar(int a, int b);
